package hls.plugin.weixin.fuwu;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.methods.StringRequestEntity;

import hls.plugin.weixin.qiye.DBUtil;
import net.sf.json.JSONObject;

public class sendPostForOpenid {
	private String urlTemplate = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid={appid}&secret={secret}";
	private String msgUrlTemplate = "https://api.weixin.qq.com/cgi-bin/message/custom/send?access_token={accessToken}";
	private int MAX_RETRY = 3;

	public String httpRequestUrl(String requestUrl, String method) throws IOException {
		HttpClient client = new HttpClient();
		HttpMethod httpMethod = null;
		String openId = "";
		if ("GET".equals(method)) {
			httpMethod = new GetMethod(requestUrl);
		} else {
			httpMethod = new PostMethod(requestUrl);
			try {
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		try {
			client.executeMethod(httpMethod);
			openId = httpMethod.getResponseHeader("openid").getValue();
			httpMethod.releaseConnection();
		} catch (HttpException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		} finally {
			if (httpMethod != null) {
				httpMethod.releaseConnection();
			}
		}

		return openId;
	}

	public String getOpenId(String url) {
		String openId = null;
		String requestUrl = url;
		try {
			openId = httpRequestUrl(requestUrl, "GET");
		} catch (IOException e) {
			e.printStackTrace();
		}

		return openId;

	}

	public String replyText2OpenId(String appid,String secret,String toOpenId, String msgType, String msg) throws IllegalArgumentException {
		String result = "failed";
		try{
			String accessToken = getAccessToken(appid,secret);
			if (isNullOrEmpty(toOpenId) || isNullOrEmpty(msg) || isNullOrEmpty(msgType)) {
				StringBuffer errorInfo = new StringBuffer("toOpenId:");
				errorInfo.append(String.valueOf(toOpenId));
				errorInfo.append("\tmsgType:");
				errorInfo.append(String.valueOf(msgType));
				errorInfo.append("\tmsg:");
				errorInfo.append(String.valueOf(msg));
				throw new IllegalArgumentException(errorInfo.toString());
			}
			String msgUrl = msgUrlTemplate.replace("{accessToken}", accessToken);
			String jsonString = "{\"touser\":\""+toOpenId+"\",\"msgtype\":\""+msgType+"\",\"text\":{\"content\":\""+msg+"\"}}";
			sendMsg(msgUrl, jsonString);
			result = "success";
		}catch(Exception e){
			e.printStackTrace();
		}

		return result;

	}
	
	public String replyText2OpenIds(String appid,String secret,String[] toOpenId, String msgType) throws IllegalArgumentException {
		String result = "failed";
		try{
			String accessToken = getAccessToken(appid,secret);
			String msgUrl = msgUrlTemplate.replace("{accessToken}", accessToken);
			for(int i=0; i<toOpenId.length; i++){
				JSONObject jsonObject = JSONObject.fromObject(toOpenId[i]);
				String openid = jsonObject.get("openid").toString();
				String msg = jsonObject.get("msg").toString();
				String jsonString = "{\"touser\":\""+openid+"\",\"msgtype\":\""+msgType+"\",\"text\":{\"content\":\""+msg+"\"}}";
				sendMsg(msgUrl, jsonString);
			}
			
			
			result = "success";
		}catch(Exception e){
			e.printStackTrace();
		}

		return result;

	}

	private boolean isNullOrEmpty(String s) {
		if (s == null || s.length() < 1) {
			return true;
		}
		return false;
	}

	public String getAccessToken(String appid,String secret) throws IllegalArgumentException, Exception {
		String accessToken = null;

		HttpClient client = new HttpClient();

		// ݿȡaccess_token
		Connection connection = DBUtil.getConnection();
		String sql = "select access_token from wfl_access_token where expire_date > ?";
		PreparedStatement pstmt = connection.prepareStatement(sql);
		pstmt.setDate(1, new Date(System.currentTimeMillis()));
		ResultSet resultSet = pstmt.executeQuery();

		// ڣʹݿaccess_token
		if (resultSet.next()) {
			accessToken = resultSet.getString(1);
		} else {
			// 
		
			if (isNullOrEmpty(appid) || isNullOrEmpty(secret)) {
				throw new IllegalArgumentException("cannot get access token");
			}
			String url = urlTemplate.replace("{appid}", appid).replace("{secret}", secret);
			GetMethod get = new GetMethod(url);
			int flag = 1;

			while (flag > 0) {
				int executeMethod = client.executeMethod(get);
				byte[] responseBody = get.getResponseBody();
				JSONObject jsonObject = JSONObject.fromObject(new String(responseBody));
				Object object = jsonObject.get("access_token");
				if (object == null) {
					System.err.println("get token failed, try again!");
					flag++;
					if (flag > MAX_RETRY) {
						flag = -1;
						throw new Exception("get token failed max times. stopped!");
					}
				} else {
					Object expire = jsonObject.get("expires_in");
					accessToken = String.valueOf(object);
					sql = "insert into wfl_access_token(access_token,expire_date,creation_date,created_by,last_update_date,last_updated_by) values('"
							+accessToken
							+"',sysdate+"
							+String.valueOf(expire)
							+"/24/60/60,sysdate,'1',sysdate,'1')";
					Statement stmt = connection.createStatement();
					// 浽ݿ
					stmt.execute(sql);
					
					flag = -1;
				}
			}
		}
		
		pstmt.close();
		connection.commit();
		connection.close();
		return accessToken;
	}
	
	private void sendMsg(String url,String msg) throws Exception{
		HttpClient client = new HttpClient();
		PostMethod postMethod = new PostMethod(url);
		RequestEntity requestEntity = new StringRequestEntity(msg,"text/xml","UTF-8");
		postMethod.setRequestEntity(requestEntity);
		int executeMethod = client.executeMethod(postMethod);
		
	}
	
	public static void main(String[] args) throws Exception{
		sendPostForOpenid sendPostForOpenid = new sendPostForOpenid();
		/*String accessToken = sendPostForOpenid.getAccessToken("wx114d72be121c0797", "f6490d5f2c58656be86fd522837db943 ");
		System.out.println(accessToken);*/
		String[] aStrings= new String[]{};
		sendPostForOpenid.replyText2OpenIds("wx114d72be121c0797", "f6490d5f2c58656be86fd522837db943", new String[]{"{'openid':'oTZ5RwCyG8mUOgf_1bX4J9nY2L-4','msg':'345'}","{'openid':'12314-4','msg':'abc'}"}, "text");
	}

}
